<?php

define ('CONTACT_FORM_SENT_NOTIFICATION',
        'Съобщението ти е изпратено!');

define ('CONTACT_FORM_MAIL_SUBJECT', 'Консултация');

define ('CONTACT_FORM_DEADLINE_MAIL_SUBJECT', 'Срок: ');

define ('CONTACT_FORM_ERROR_LIST_MESSAGE',
        'Възникна грешка:');

define ('CONTACT_FORM_ERROR_NON_MATCHING_EMAILS',
        'Електронният ти адрес не е точен.');

define ('CONTACT_FORM_ERROR_EMTPY_TEXT_FIELD',
        'Оставил/а си съобщението празно.');

define ('CONTACT_FORM_ERROR_INCORRECT_SECRET_CODE',
        'Защитният код е грешно въведен.');


function make_contact_form_options ($selected_list)
{
  $html = '';

  if ($selected_list)
    {
      foreach ($GLOBALS['MAILING_LISTS'] as $list)
        {
          if (!strcmp ($list['name'], $selected_list))
              $html .= "<option value=\"${list['name']}\" selected>${list['title']}</option>\n";
          else
              $html .= "<option value=\"${list['name']}\">${list['title']}</option>\n";
        }
    }
  else
    {
      foreach ($GLOBALS['MAILING_LISTS'] as $list)
        {
          $html .= "<option value=\"${list['name']}\">${list['title']}</option>\n";
        }
    }

  return $html;
}


function make_contact_form ($values)
{
  $expected_secret_code = '';
  for ($i = 0; $i < 6; ++$i) $expected_secret_code .= rand() % 10;

  $name = '';
  $email = '';
  $email_again = '';
  $deadline = '';
  $text = '';
  $get_copy = '';
  $news_subscribe = '';

  if ($values)
    {
      $name           = isset ($values['name'       ]) ? " value=\"${values['name'       ]}\"" : '';
      $email          = isset ($values['email'      ]) ? " value=\"${values['email'      ]}\"" : '';
      $email_again    = isset ($values['email_again']) ? " value=\"${values['email_again']}\"" : '';
      $deadline       = isset ($values['deadline'   ]) ? " value=\"${values['deadline'   ]}\"" : '';
      $text           = isset ($values['text'       ]) ? $values['text'] : '';
      $get_copy       = isset ($values['get_copy'])       && !strcmp ($values['get_copy']      , 'on') ? ' checked' : '';
      $news_subscribe = isset ($values['news_subscribe']) && !strcmp ($values['news_subscribe'], 'on') ? ' checked' : '';
    }

  $mailing_list = '';
  if (isset ($values['mailing_list']))
    {
      $mailing_list = $values['mailing_list'];
      $title_option_selected = '';
    }
  else
    {
      $title_option_selected = ' selected';
    }

  $html  = "<form method=\"POST\" action=\"./#contact-form\">\n";
  $html .= "<input name=\"form\" value=\"contact_form\" type=\"hidden\">\n";
  $html .= "<ul>\n";
  $html .= "<li><input name=\"name\" placeholder=\"Твоето име (може псевдоним)\" type=\"text\" $name/></li>\n";
  $html .= "<li><input name=\"email\" placeholder=\"Твоят e-mail\" type=\"email\" required$email/></li>\n";
  $html .= "<li><input name=\"deadline\" placeholder=\"Отбележи, ако изтича някакъв срок\" type=\"text\" $deadline/></li>\n";
  $html .= "<li>\n";
  $html .= "<select name=\"mailing_list\">\n";
  $html .= "<option value=\"\" disabled ${title_option_selected}>Избери...</option>\n";
  $html .= make_contact_form_options ($mailing_list);
  $html .= "</select>\n";
  $html .= "</li>\n";
  $html .= "<textarea name=\"text\" placeholder=\"Кажи за какво става въпрос\" required>$text</textarea>\n";
  $html .= "<li><label><input type=\"checkbox\" name=\"get_copy\"$get_copy>Искам копие от съобщението</label></li>\n";
  $html .= "<li><label><input type=\"checkbox\" name=\"news_subscribe\"$news_subscribe>Искам да получавам новини</label></li>\n";
  $html .= "<li><input name=\"email_again\" placeholder=\"Твоят e-mail (повтори)\" type=\"email\" required$email_again/></li>\n";
  $html .= "<li>\n";
  $html .= "  <p class=\"secret-code\">$expected_secret_code</p>\n";
  $html .= "  <input name=\"secret_code\" placeholder=\"Въведи 6-цифрения код\" type=\"text\" required autocomplete=\"off\"/>\n";
  $html .= "  <input name=\"expected_secret_code\" value=\"$expected_secret_code\" type=\"hidden\">\n";
  $html .= "</li>\n";
  $html .= "</ul>\n";
  $html .= "<p class=\"buttons\"><button type=\"reset\">Изчисти</button> <button type=\"submit\">Изпрати</button></p>\n";
  $html .= "</form>\n";

  return $html;
}


function get_contact_form_errors ($values)
{
  $errors = [];

  $valid_emails = TRUE;

  if (isset ($values['email']))
    {
      $values['email'] = trim ($values['email']);
      if (strlen ($values['email']) < 3)
        {
          array_push ($errors, 'Ivalid email address.');
          $valid_emails = FALSE;
        }
    }
  else
    {
      array_push ($errors, 'Email address is missing.');
      $valid_emails = FALSE;
    }

  if (isset ($values['email_again']))
    {
      $values['email_again'] = trim ($values['email_again']);
      if (strlen ($values['email_again']) < 3)
        {
          array_push ($errors, 'Ivalid confirmation email address.');
          $valid_emails = FALSE;
        }
    }
  else
    {
      array_push ($errors, 'Confirmation email address is missing.');
      $valid_emails = FALSE;
    }

  if ($valid_emails && strcmp ($values['email'], $values['email_again']))
    {
      array_push ($errors, CONTACT_FORM_ERROR_NON_MATCHING_EMAILS);
    }

  if (isset ($values['text']))
    {
      $values['text'] = trim ($values['text']);
      if (!strlen ($values['text']))
        {
          array_push ($errors, CONTACT_FORM_ERROR_EMTPY_TEXT_FIELD);
        }
    }
  else
    {
      array_push ($errors, 'Text field is missing.');
    }

  if (isset ($values['mailing_list']))
    {
      $mailing_list = $values['mailing_list'];
      $valid_list = FALSE;
      foreach ($GLOBALS['MAILING_LISTS'] as $list)
        {
          if (!strcmp ($list['name'], $mailing_list)) {$valid_list = TRUE; break;}
        }

      if (!$valid_list)
        {
          array_push ($errors, 'Invalid list specified.');
        }
    }

  $valid_secret_codes = TRUE;

  if (isset ($values['secret_code']))
    {
      $values['secret_code'] = trim ($values['secret_code']);
      if (!$values['secret_code'])
        {
          array_push ($errors, 'Secret code field is empty.');
          $valid_secret_codes = FALSE;
        }
    }
  else
    {
      array_push ($errors, 'Secret code field is missing.');
      $valid_secret_codes = FALSE;
    }

  if (isset ($values['expected_secret_code']))
    {
      $values['expected_secret_code'] = trim ($values['expected_secret_code']);
      if (!$values['expected_secret_code'])
        {
          array_push ($errors, 'Expected secret code filed is empty.');
          $valid_secret_codes = FALSE;
        }
    }
  else
    {
      array_push ($errors, 'Expected secret code field is missing.');
      $valid_secret_codes = FALSE;
    }

  if ($valid_secret_codes && strcmp ($values['secret_code'], $values['expected_secret_code']))
    {
      array_push ($errors, CONTACT_FORM_ERROR_INCORRECT_SECRET_CODE);
    }

  return $errors;
}


function make_contact_form_error_list ($errors) {
  $html  = "<div class=\"errors\">\n";
  $html .= "<p>" . CONTACT_FORM_ERROR_LIST_MESSAGE . "</p>\n";
  $html .= "<ul>\n";
  foreach ($errors as $error) $html .= "  <li>$error</li>\n";
  $html .= "</ul>\n";
  $html .= "</div>\n";

  return $html;
}


function use_contact_form () {
  $html = "<div id=\"contact-form\">\n";

  if (isset ($_POST['form']) && $_POST['form'] === 'contact_form')
    {
      $errors = get_contact_form_errors ($_POST);
      if (!$errors)
        {
          $name     = isset ($_POST['name']) ? $_POST['name'] : '';
          $email    = $_POST['email'];
          $reply_to = [$email, $name];
          $body     = $_POST['text'];

          $deadline = isset ($_POST['deadline']) ? $_POST['deadline'] : '';
          if ($deadline)
            {
              $subject = CONTACT_FORM_DEADLINE_MAIL_SUBJECT . $deadline;
              $body = "Срок: $deadline\n\n" . $body;
            }
          else
            {
              $subject = CONTACT_FORM_MAIL_SUBJECT;
            }

          $cc_list  = isset ($_POST['get_copy']) && !strcmp ($_POST['get_copy'], 'on') ? [$reply_to] : [];

          $recipients = NULL;
          $mailing_list_name = isset ($_POST['mailing_list']) ? $_POST['mailing_list'] : NULL;
          if ($mailing_list_name)
            {
              foreach ($GLOBALS['MAILING_LISTS'] as $mailing_list)
                {
                  if (!strcmp ($mailing_list['name'], $mailing_list_name))
                    {
                      $recipients = $mailing_list['recipients'];
                      break;
                    }
                }
            }
          else
            {
              $recipients = $GLOBALS['MAILING_LISTS'][0]['recipients'];
            }


          $errors = send_mail ($recipients, $cc_list, $reply_to, $subject, $body);

          if (isset ($_POST['news_subscribe']) &&
              !strcmp ($_POST['news_subscribe'], 'on'))
            {
              push_notification (subscribe_for_news ($email));
            }
        }

      if ($errors)
        {
          $html .= make_contact_form_error_list ($errors);
          $html .= make_contact_form ($_POST);
          foreach ($errors as $error) push_notification ($error);
        }
      else
        {
          push_notification (CONTACT_FORM_SENT_NOTIFICATION);
          $html .= "<p>" . CONTACT_FORM_SENT_NOTIFICATION . "</p>\n";
        }
    }
  else
    {
       $html .= make_contact_form (NULL);
    }

  $html .= "</div>\n";

  return $html;
}

?>
