<h2>Цифрово шифроване и подписване</h2>

<p><img src="asymmetric-keys.png" width="90" title="Удостоверяване на интегритет и автентичност"/></p>

<p><strong>GnuPG</strong> (<a href="https://gnupg.org/" target="_blank"><strong>GPG</strong></a>) е <a href="https://bg.wikipedia.org/wiki/%D0%A1%D0%B2%D0%BE%D0%B1%D0%BE%D0%B4%D0%B5%D0%BD_%D1%81%D0%BE%D1%84%D1%82%D1%83%D0%B5%D1%80" target="_blank"><strong>Свободен софтуер</strong></a> за цифрово шифроване, разшифроване, подписване и проверка на цифровите подписи. Последното позволява да се удостовери <strong>автентичността</strong> (произход от когото очакваш) и <strong>интегритетът</strong> (липса на последващи промени) на подписаните файлове. Ако дори само един символ не съвпада, ще бъде изведен отрицателен криптографски отговор и за теб ще бъде ясно, че файловете са били променени (умишлено или случайно, например поради грешка при копирането); или не са подписани от когото очакваш.</p>

<p><img src="asymmetric-signing.png" width="400" title="Проверка на цифров подпис (по материали от  Wikipedia)"/></p>

<p>Всичко тръгва от т.нар. <strong>„Асиметрично шифроване“</strong> (<a href="https://en.wikipedia.org/wiki/Public-key_cryptography" target="_blank"><strong>Asymmetric Encryption</strong></a>), което разчита на двойка иманентно свързани шифровъчни ключове – „публичен“ и „частен“. Първият от тези ключове е <em>публично</em> известен, а вторият се пази от притежателя му в дълбока тайна. „Публичният“ ключ може да шифрова съдържание, но не може да го разшифрова. „Частният“ ключ обратно – може да разшифрова съдържание, което е шифровано с „публичния“ ключ, но може още нещо – да подпише определено съдържание. <strong>Автентичността</strong> и <strong>интегритетът</strong> на положения цифров подпис след това може да се проверява от всеки, който притежава копе от „публичния“ ключ, иманентно свързан с използвания за подписването „частен“ ключ.</p>

<p>Самият цифров подпис представялва поредица от изглеждащи като „безразборни“ символи, които се явяват сложна криптографска производна от символите в „частния“ ключ и символите в подписания файл. С помощта на „публичния“ ключ може да бъде осъществена криптографска проверка за това дали символите в цифровия подпис са наистина производна от „частния“ ключ и от символите в проверявания файл. Ако всичко съвпадне, ще бъде изведен положителен криптографски отговор и за теб ще бъде ясно, че файлът е точно подписаният от притежателя на „частния“ ключ, иманентно свързан с използвания за проверката „публичен“ ключ.</p>

<p>Възниква въпросът – <em>Как да се удостовери, че „публичният“ ключ и иманентно свързаният с него „частен“ ключ принадлежат именно на този, на когото се доверяваш?</em></p>

<p>Частично решение представляват т.нар. <a href="https://crc.bg/bg/rubriki/560/elektronni-udostoveritelni-uslugi" target="_blank"><strong>Доставчици на удостоверителни услуги</strong></a>, които съгласно действащата <a href="https://lex.bg/laws/ldoc/2135180800" target="_blank"><strong>нормативна уредба</strong></a> поддържат удостоверяващи списъци с „публични“ ключове и надеждно установените идентификационни данни на техните притежатели. Недостатък в тази система е, че Доставчикът задължително създава двойката иманентно свързани шифровъчни ключове при себе си; нямаш технологична гаранция, че твоят „частен“ ключ е бил заличен необратимо от базите с данни на Доставчика, след като е бил инсталиран на твоето средство за цифрово подписване. Ето защо ние предпочитаме да създаваме нашите шифровъчни ключове сами.</p>

<p><img id="1" src="fingerprint.png" width="90" title="Идентифициране на правилния „публичен“ ключ"/></p>

<p>Още преди да съществуват нормативно регулирани Доставчици на удостоверителни услуги, привържениците на цифровата криптография са създали и поддържат т.нар. <strong>„Мрежа на доверието“</strong> (<a href="https://en.wikipedia.org/wiki/Web_of_trust" target="_blank"><strong>Web of Trust</strong></a>). Това е система от публично достъпни бази с данни, откъдето можеш да свалиш копие от интересуващ те „публичен“ ключ; и механизъм на взаимно потвърждаване, при който можеш да провериш дали за интересуващия те „публичен“ ключ е потвърдено (от източници, на които вярваш), че действително принадлежи на този, на когото искаш да се довериш.</p>

<p>За да може да се разграничи един „публичен“ ключ от друг (което не е удобно да се направи „с просто око“, тъй като всичките си приличат – представляват файлове с понякога хиляди изглеждащи като „безразборни“ символи), се използва т.нар. <strong>„Идентификатор“</strong> (<a href="https://en.wikipedia.org/wiki/Fingerprint_(computing)" target="_blank"><strong>Fingerprint</strong></a>). „Идентификаторът“ представлява сложна криптографска производна (в случая от интересуващия те „публичен“ ключ), по която можеш да провериш дали сваленият от публично достъпните бази с данни (или откъдето и да било другаде) „публичен“ ключ е точно този, който те интересува.</p>

<p>„Идентификаторът“ на един „публичен“ ключ е напълно различен от този на който и да било друг „публичен“ ключ; и дори само един символ от „публичния“ ключ да бъде променен, ще бъде извлечен напълно различен „идентификатор“. Въпреки последното обаче, трябва щателно да проверяваш всичките <strong>40</strong> символи в „идентификатора“ – защото съществуват (макар и много редки) случаи на частично съвпадащи „идентификатори“.</p>

<p>„Идентификаторът“ на нашия „публичен“ ключ е този:</p>

<p><strong>AE06191DE7B72F74ACE2BB257B62D2A7D14C089B</strong></p>

<p>Най-проститят начин да се убедиш, че тъкмо този „идентификатор“ съответства на нашия „публичен“ ключ, е като се свържеш с нас по независим канал и получиш потвърждение за неговата <strong>автентичност</strong> и <strong>интегритет</strong>. Друг начин е да потърсиш в „Мрежата на доверието“ потвърждения от източници, на които вярваш. За тази цел трябва да познаваш достатъчно голям брой потребители, които се занимават с криптография и потвърждават автентичността и интегритета на интересуващите те „публични“ ключове.</p>

<p><img id="1" src="free-software.png" width="90" title="Свободен софтуер за криптографска проверка"/></p>

<p>Нашата двойка „асиметрични“ ключове за (раз)шифроване и цифрово подписване е създадена със споменатия по-горе софтуер <strong>GnuPG</strong>, който позволява и криптографска проверка на <strong>автентичността</strong> и <strong>интегритета</strong> на подписаните файлове. Това е <strong>Свободен софтуер</strong>, който можеш да свалиш, да инсталираш на своя компютър и да ползваш за своите нужди, без да искаш разрешение от някого и без да дължиш каквото и да било.</p>

<p>Държим толкова много на <strong>Свободния софтуер</strong>, защото само той позволява да проучваш начина му на функциониране и да го променяш, ако не отговаря на нуждите ти; или да възложиш на твой доверен специалист да направи това за теб. Следователно само <strong>Свободният софтуер</strong> предоставя <em>действителни технологични гаранции</em> за това, че работи точно така, както се твърди – защото всеки може да провери (или да възложи да бъде проверено) дали в него няма вградени някакви <strong>„Задни врати“</strong> (<a href="https://en.wikipedia.org/wiki/Backdoor_(computing)" target="_blank"><strong>Backdoors</strong></a>); и само <strong>Свободният софтуер</strong> предоставя <em>действителни технологични гаранции</em> за това, че потребителят няма да бъде поставен в зависимост от конкретна разработваща компания, която единствена има право да знае как функционира софтуерът и единствена има право да го променя – защото всеки програмист (включително ти или твоят доверен програмист) има право да преработи софтуера така, както желаеш.</p>

<p>Ето защо – за да разчиташ на <em>действителни технологични гаранции</em> за начина на функциониране на софтуера, трябва да ползваш <strong>Свободния софтуер</strong>. Продукти като <strong>Windows</strong>, <strong>MacOS</strong>, <strong>iOS</strong> и дори <strong>Android</strong> не са свободни – програмният код при тях е скрит (изцяло или отчасти), не може да бъде подложен на независима проверка и не може да бъде променян съгласно нашите нужди (освен ако разработващата компания не реши да го направи). Така <strong>Несвободният софтуер</strong> прави потребителите зависими от разработващата компания и ги оставя да се надяват, че дадените обещания за начина на функциониране на софтуера ще бъдат спазени – като ги лишава от всякакви <em>технологични гаранции</em> за това.</p>

<p>Описаният проблем ни кара да предпочитаме да се доверяваме на <strong>Свободния софтуер</strong> – както за нашите операционни системи, така и за потребителските софтуерни модули (включително тези, с които подписваме цифрово и проверяваме положените цифрови подписи). Сред предпочитаните от нас <a href="https://www.gnu.org/distros/free-distros.en.html" target="_blank"><strong>Свободни операционни системи</strong></a> (в които са вградени всичките необходими приложения за повечето потребители) можем да посочим <a href="https://trisquel.info/" target="_blank"><strong>Trisquel</strong></a>, <a href="https://www.parabola.nu/" target="_blank"><strong>Parabola</strong></a>, <a href="https://www.dragora.org/" target="_blank"><strong>Dragora</strong></a>, <a href="http://www.gnewsense.org/" target="_blank"><strong>gNewSense</strong></a>. Всички те по нищо не отстъпват на своите несвободни алтернативи, дори напротив!</p>

<p><img src="command-line.png" width="90" title="Команди за проверка в Свободна софтуерна среда"/></p>

<p>Съществуват много несвободни софтуерни приложения, които можеш да закупиш и използваш за криптографска проверка на <strong>автентичността</strong> и <strong>интегритета</strong> на интересуващите те цифрово подписани файлове. Ние обаче не можем да гарантираме достоверността на такава проверка – единствено можеш да разчиташ на дадените обещания от разработващата компания. Ако въпреки това решеш да ползваш <strong>Несвободен софтуер</strong> и се нуждаеш от помощ, следвай инструкциите на твоя системен администратор.</p>

<p>Ако работиш със <strong>Свободен софтуер</strong> (или решиш да пробваш такъв софтуер от „жив“ носител (<strong>CD</strong>, <strong>DVD</strong>, <strong>Flash</strong>-памет или <strong>SD</strong>-карта), без да го инсталираш), можеш да последваш дадените по-долу указания, като отвориш <strong>Терминала</strong> (<strong>Terminal</strong>) на избраната от теб <strong>Свободна операционна система</strong> и въвеждаш дадените прости текстови команди.</p>

<ul>

  <li><p>Свали цифрово подписания файл и свързания с него цифров подпис в избрана от теб директория.</p></li>

  <li><p>Свали от „Мрежата на доверието“ нашия „публичен“ шифровъчен ключ – с тази команда:</p>

<p><pre><strong>gpg --recv-keys AE06191DE7B72F74ACE2BB257B62D2A7D14C089B</strong></pre></p>

<p>(копирай внимателно, постави в Терминала и натисни <code><strong>[Enter]</strong></code>)</p></li>

  <li><p>Извърши самата проверка – с тази команда:</p>

<p><pre><strong>gpg --verify /адрес/директория/файл</strong></pre></p>

<p>(ако Терминалът се намира в директорията, където си поставил/а проверявания файл и цифровия подпис, не е необходимо да посочваш адрес и директория; въведи само '<code><strong>файл</strong></code>')</p>

<p>Ще бъде изведено предупреждение, че няма доказателства използваният за подписването „частен“ ключ да принадлежи наистина на този, на когото се доверяваш. В допълнение към това при положителен криптографски отговор ще бъде изведено съобщение <code><strong>Good signature</strong></code> (Добър подпис); или при отрицателен криптографски отговор – съобщение <code><strong>Bad signature</strong></code> (Лош подпис). И в двата случая ще бъдат изведени данните, които притежателят на двойката „асиметрични“ ключове е въвел при тяхното създаване. В нашия случай тези данни изглеждат така:</p>

<p><pre><strong>"www.Advocati.org (адвокатска тайна) &ltadvocati@gmx.com>"</strong></pre></p>

<p>Тези данни обаче не са надеждни – всеки може да създаде двойка „асиметрични“ ключове и да впише същите данни (за разлика от данните при Доставчиците на удостоверителни услуги, които се извличат надеждно). Поради това не следва да се доверяваш на такива данни – вместо това е добре да извлечеш „идентификатора“ на интересуващия те „публичен“ ключ и да потърсиш начин той да бъде потвърден от притежателя му.</p>
</li>
  <li><p>Можеш да извлечеш „идентификатора“ на инсталиран в твоята система „публичен“ ключ с тази команда:</p>

<p><pre><strong>gpg --fingerprint данни</strong></pre></p>

<p>(където под '<code><strong>данни</strong></code>' разбираме каквато и да е разпознаваема част от данните, записани за интересуващия те „публичен“ ключ)</p></li>

</ul>

<p>Независимо, че работата с текстови команди към компютъра на пръв поглед изглежда трудна и предназначена само за програмисти, в действителност това е най-прекият и най-лесният начин да накараш системата да направи това, което желаеш. <strong>Ако опиташ, няма да съжаляваш!</strong></p>

<p><a href="/about/site/#1"><strong>(обратно към файловете за сваляне)</strong></a></p>
